bin/mdw-build: Missing `;;' in `case'.
[profile] / bin / mdw-build
CommitLineData
7ee12623
MW
1#! /bin/bash
2###
3### Build script for Debian packages
4###
5### (c) 2008 Mark Wooding
6###
7
8###----- Licensing notice ---------------------------------------------------
9###
10### This program is free software; you can redistribute it and/or modify
11### it under the terms of the GNU General Public License as published by
12### the Free Software Foundation; either version 2 of the License, or
13### (at your option) any later version.
14###
15### This program is distributed in the hope that it will be useful,
16### but WITHOUT ANY WARRANTY; without even the implied warranty of
17### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18### GNU General Public License for more details.
19###
20### You should have received a copy of the GNU General Public License
21### along with this program; if not, write to the Free Software Foundation,
22### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
23
85b7c21c
MW
24###--------------------------------------------------------------------------
25### Conventions for build systems.
26###
27### This script is designed to work with a variety of `make'-based build
28### systems, but there are a number of conventions which must be followed if
29### this is going to work properly.
30###
31### * There must be a `configure.ac', `configure.in', or `.links' file, or
32### a `.git' directory in the project top-level, so that we can find it.
33###
34### * The following `make' variables must be assigned in the top-level
35### Makefile, after `mdw-build' has constructed it.
36###
37### distdir The name of the top-level project directory in the
38### source distribution, and the base name for
39### distribution archives; should be of the form
40### `PROJECT-VERSION'.
41###
42### The following `make' targets must be available in the top-level
43### Makefile.
44###
45### dist Write to $(distdir).tar.gz a source distribution of
46### the package.
47###
48### distcheck As for `dist', but also build and test the project.
49###
50### * The source distribution constructed by `make dist' must contain a file
51### $(distdir)/RELEASE containing the release name. This isn't currently
52### tested, but it might be later.
53
7ee12623
MW
54set -e
55
56###--------------------------------------------------------------------------
57### Parse options.
58
59usage () {
60 cat <<EOF
61Usage: $0 [-vr] BUILDOPT
62
63Build options:
64
65 [no]checkout[=REV]
66 [no]release
9c586ae1 67 [no]setup[=RUNE]
7ee12623
MW
68 [no]distcheck
69 [no]debian
70 [no]upload
71 [no]clean
f5b3423e 72 [no]vpath
d87d7867 73 [no]native
7ee12623
MW
74EOF
75}
76
77## Parse simple options.
78verbose=no
79while getopts "hvr" opt; do
80 case "$opt" in
81 h) usage; exit 0 ;;
82 v) verbose=yes ;;
83 *) exit 1 ;;
84 esac
85done
86shift $((OPTIND - 1))
87
88## Parse the build options.
89checkout=yes
90checkoutrev=HEAD
91build=test
92setup=yes
9c586ae1 93setupcmd=mdw-setup
7ee12623
MW
94distcheck=yes
95debian=yes
96upload=yes
97clean=yes
f5b3423e 98vpath=yes
d87d7867 99native=yes
7ee12623
MW
100for opt; do
101 case "$opt" in
102 checkout) checkout=yes checkoutrev=HEAD ;;
103 checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
7ee12623
MW
104 release) build=release ;;
105 norelease) build=test ;;
9c586ae1
MW
106 setup) setup=yes setupcmd=mdw-setup ;;
107 setup=*) setup=yes setupcmd=${opt#*=} ;;
7ee12623 108
d87d7867 109 distcheck | debian | upload | clean | vpath | native)
7ee12623
MW
110 eval "$opt=yes"
111 ;;
50c72b0f 112 nocheckout | nosetup | nodistcheck | nodebian | \
d87d7867 113 noupload | noclean | novpath | nonative)
7ee12623
MW
114 eval "${opt#no}=no"
115 ;;
116 *)
117 usage >&2
118 exit 1
119 ;;
120 esac
121done
122
84dd9069
MW
123## Parse DEB_BUILD_OPTIONS.
124jobs=1
125set -- $DEB_BUILD_OPTIONS
126for opt; do
127 case "$opt" in
128 parallel=*) jobs=${opt#*=} ;;
129 esac
130done
131
132makeopts=""
133case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
134
7ee12623
MW
135###--------------------------------------------------------------------------
136### Utility functions.
137
138exec 3>&2 4>/dev/null 5>&2
139
140notify () {
141 colour=$1 message=$2
142 echo $message >&4
143 echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&5
144}
145
146fail () {
147 notify 1 "!!! $*"
148 exit 1
149}
150
f282ba46
MW
151warn () {
152 case $build in
153 release) fail "$*" ;;
154 *) notify 5 "??? $*" ;;
155 esac
156}
157
7ee12623
MW
158info () {
159 notify 6 "--- $*"
160}
161
162assign () {
163 info "$1 = $2"
164 eval "$1=$2"
165}
166
167runx () {
168 notify 2 "+++ $*"
169 "$@" 2>&3 || fail "$1: exit $?"
170}
171
172run () { runx "$@" >&3; }
173
174yesno () {
175 echo -n "(test $*)" >&4
176 if "$@" >&4 2>&4; then
177 echo "(yes)" >&4
178 echo yes
179 else
180 echo "(no)" >&4
181 echo no
182 fi
183}
184
185###--------------------------------------------------------------------------
186### Do the building.
187
188## Find the top-level package directory.
d43de82b
MW
189while [ ! -f configure.ac -a ! -f configure.in -a \
190 ! -f .links -a ! -d .git ]; do
7ee12623
MW
191 case "$(pwd)" in
192 /)
193 fail "couldn't find top-level directory"
194 ;;
195 esac
196 cd ..
197done
198assign srcpath $(pwd)
199
200## Construct the output directory.
201assign releasepath $srcpath/dist-$build
47539e6a 202chmod -R +w $releasepath 2>/dev/null || :
7ee12623
MW
203rm -rf $releasepath 2>/dev/null || :
204mkdir $releasepath
205case $verbose in
206 no)
207 exec 4>$releasepath/mdw-build.log 3>&4 ||
208 fail "Failed to create log."
209 ;;
210esac
211
f282ba46 212## Do we have a Git repository?
7ee12623
MW
213case "$checkout,$setup,$(yesno [ -d $srcpath/.git ])" in
214 yes,no,*)
215 fail "Inconsistent options: can't check out without setup."
216 ;;
217 yes,yes,no)
218 info "No Git repository found."
f282ba46 219 checkout=no gitver=none
7ee12623
MW
220 ;;
221 yes,yes,yes)
222 cd $srcpath
223 [ "$(git ls-files -m)" = "" ] ||
f282ba46 224 warn "working tree has uncommitted changes"
40196145 225 gitver=$(git describe --abbrev=4)
66305913 226 ;;
f282ba46
MW
227esac
228
229## Is there Debian build equipment?
230case "$debian,$(yesno [ -d $srcpath/debian ])" in
231 yes,no)
232 info "No debian directory found."
233 debian=no debver=none
234 ;;
f0905f8c
MW
235 no,*)
236 debver=none
237 ;;
f282ba46 238 yes,yes)
7219881d 239 debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p' | tr \~ -)
40196145
MW
240 debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
241 debname=$(git config user.name) debemail=$(git config user.email)
f282ba46
MW
242 ;;
243esac
244
245## Check the version number.
40196145 246hack_dch_p=no
f282ba46
MW
247case "$gitver,$debver" in
248 none,* | *,none)
249 ;;
250 *)
40196145 251 if [ "$gitver" != "$debver" ]; then
f282ba46 252 warn "Git version $gitver doesn't match Debian version $debver"
40196145
MW
253 hack_dch=yes
254 fi
f282ba46
MW
255 ;;
256esac
257
f5b3423e 258## Maybe check out a copy of the source.
f282ba46
MW
259case "$checkout" in
260 yes)
7ee12623
MW
261 cd $releasepath
262 run git clone -sn $srcpath/.git _source
263 assign srcpath $releasepath/_source
264 cd $srcpath
265 run git checkout -b mdw-build $checkoutrev
266 ;;
267esac
268
269## Maybe refresh the build machinery.
270case "$setup" in
271 yes)
9c586ae1 272 run $setupcmd
7ee12623
MW
273 ;;
274esac
275
276## Initialize the build directory.
f5b3423e
MW
277case "$vpath,$(yesno [ -e $srcpath/configure ])" in
278 yes,yes)
279 assign buildpath $releasepath/_build
280 mkdir $buildpath
281 cd $buildpath
282 run $srcpath/configure
283 ;;
284 no,yes)
285 info "VPATH build disabled"
286 assign buildpath $srcpath
287 distcheck=no
288 cd $srcpath
289 run ./configure
290 ;;
291 *,no)
292 info "no configure script"
293 assign buildpath $srcpath
294 cd $srcpath
295 ;;
296esac
7ee12623
MW
297
298## Discover the release name.
299cat >find-distdir.mk <<'EOF'
300include Makefile
301print-distdir:
dd8d9a6c 302 @echo >&3 $(distdir)
7ee12623 303EOF
dd8d9a6c
MW
304assign distdir \
305 $({ make -f find-distdir.mk print-distdir >/dev/null 2>&1; } 3>&1)
7ee12623
MW
306
307## Get a tarball distribution.
308case "$distcheck" in
309 yes)
84dd9069 310 run make $makeopts distcheck
7ee12623
MW
311 ;;
312 no)
84dd9069 313 run make $makeopts dist
7ee12623
MW
314 ;;
315esac
316
317cd $releasepath
318
d87d7867
MW
319case $native in
320 yes)
321 if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
322 then
323 fail "missing RELEASE file in distribution"
324 fi
325 ;;
326esac
7ee12623
MW
327
328run mv $buildpath/$distdir.tar.gz .
47f56ea2
MW
329case $build in
330 release)
331 run gpg -u$(mdw-conf releasekey) -ab -o$distdir.tar.gz.gpg \
332 $distdir.tar.gz
333 ;;
334esac
7ee12623
MW
335
336## Maybe build the Debian packages.
f282ba46
MW
337case "$debian" in
338 yes)
7ee12623
MW
339 run tar xvfz $distdir.tar.gz
340 cd $distdir
40196145
MW
341 case $hack_dch in
342 yes)
343 dver=$(echo $gitver | sed 's/-/+/; s/-/./g')
344 now=$(date -R)
345 cat - debian/changelog >debian/changelog.new <<EOF
346$debsrc ($dver) experimental; urgency=low
347
348 * Hacking in process, not intended for release.
349
350 -- $debname <$debemail> $now
351
352EOF
353 mv debian/changelog.new debian/changelog
354 ;;
355 esac
7ee12623
MW
356 run dpkg-buildpackage -k$(mdw-conf releasekey)
357 ;;
358esac
359
360## Maybe upload Debian packages.
361cd $releasepath
362case "$upload,$build" in
363 yes,test)
364 info "Test build: not uploading."
365 ;;
366 yes,release)
25d80caa 367 run rsync $distdir.tar.gz $distdir.tar.gz.gpg \
9a472b9c 368 $(mdw-conf upload-target ftp.distorted.org.uk:~ftp/pub/mdw/)
7ee12623
MW
369 case "$debian" in
370 yes)
9a472b9c 371 run dput -f $(mdw-conf dput-target distorted) *.changes
7ee12623
MW
372 ;;
373 esac
374esac
375
376## Tidy up.
377case "$clean" in
378 yes)
379 rm -rf $releasepath/$distdir
380 rm -rf $releasepath/_source
381 rm -rf $releasepath/_build
382 ;;
383esac
384
385## Done.
386info "All OK."
387
388###----- That's all, folks --------------------------------------------------